var arr = []
const { pid, ppath } = require('../plug-in/fk2Path');
const fs = require('fs');
if (!fs.existsSync(pid)) {
    fs.mkdirSync(pid)
    return
}
const data = fs.readdirSync(pid)
const { check } = require('../plug-in/psNode');
const logs = require('../plug-in/colorLog');
if (data.length > 0) {
    // 还有任务执行
    async function checkFile() {
        logs.g('To get the task list , Please patience to wait...');
        logs.skyBlue('0%')
        for (const key in data) {
            try {
                var obj = {};
                const res = await check(data[key]);
                const f = JSON.parse(fs.readFileSync(ppath(data[key])));
                if(f.code!=2){
                    obj.name = f.name;
                    // obj.command = f.comd;
                    obj.mode = f.code == 2 ? 'cluster' : 'fork';
                    obj.status = res == 0 ? 'stopped' : 'online';
                    obj.pid = Number(data[key]);
                    obj.cpu = res==0?0:f.cpu?f.cpu:0;
                    obj.memory = res==0?0:f.memory?f.memory:0;
                    arr.push(obj);
                }
                const account =  parseInt((Number((key))+1)/data.length*100);
                logs.skyBlue(account+'%')
            } catch (error) {
                logs.skyBlue('Waiting ...')
            }
        }
        console.log('\r');
        logs.g('Task details form!');
        logs.close();
        console.table(arr);
    }
    checkFile();
} else {
    console.log('没有任务！');
}